/* sockcheck.h - insecure proxy checking
 * Copyright 2000 srvx Development Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: sockcheck.h,v 1.6.4.4 2002/01/10 17:05:03 entrope Exp $
 */

#if !defined(SOCKCHECK_H)
#define SOCKCHECK_H

struct sockcheck_stats {
    unsigned int checked_ip_count;
    unsigned int failed_ip_count;
    unsigned int checking_ip_count;
    unsigned int checking_ip_max;
    unsigned int pending_ip_count;
    unsigned int test_count;
    unsigned int cached_ip_count;
};

#if defined(HAVE_POLL) && defined(HAVE_PTHREAD) && !defined(__CYGWIN__)
#define SOCKCHECK_USABLE 1
#else
#define SOCKCHECK_USABLE 0
#endif

void sockcheck_init(void);
const char *sockcheck_add_test(const char *desc);
void sockcheck_queue_address(unsigned long addr);
int sockcheck_uncache_host(const char *name);
void sockcheck_get_stats(struct sockcheck_stats *stats);

#endif /* !defined(SOCKCHECK_H) */
